<?php
/*************************************************************************************/
/*                                                                                   */
/*      Thelia	                                                            		 */
/*                                                                                   */
/*      Copyright (c) Octolys Development		                                     */
/*		email : thelia@octolys.fr		        	                             	 */
/*      web : http://www.octolys.fr						   							 */
/*************************************************************************************/
/*      Module Optimisation de Thelia                                      */
/*      Script : Zfoptimisationmoteur.class.php                                               */
/*      Copyright (c) ZEOS-FRANCE                                                    */
/*      email : contact@zeos-france.fr                                               */
/*		plugin ralis  partir des informations d'optimisation fournies par :
		- roadster31 : optimisations moteur
		- pierrezf		: creation des index non uniques sur les colonnes de certaines tables			*/
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/

include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
require_once realpath(dirname(__FILE__))."/classes/Mysql_static.class.php";
require_once realpath(dirname(__FILE__))."/classes/Zfquerycache.class.php";


class Zfoptimisationmoteur extends PluginsClassiques{
	//proprietes privees
	private $myClassName ="Zfoptimisationmoteur";
	
	//proprietes publiques
	public $objZFoptimisationcache;

	function Zfoptimisationmoteur(){
		$this->PluginsClassiques();
		 
		if(!isset($this->objZFoptimisationcache)){
				$this->objZFoptimisationcache = new ZfQueryCache();
		}
		
	}

	function init(){
	}

	function destroy(){
	}



	/*
		checkIsEnabled : renvoit le statut du plugin dans Thelia (activ ou dsactiv)
	*/
	function checkIsEnabled(){
		$status  = 0;
		//requete sql dans la table modules
		$objCnx = new Cnx();
		$query =" SELECT actif FROM modules WHERE nom='zfoptimisationmoteur'  " ;
		$resul = mysql_query($query, $objCnx->link) 
				or die("Impossible de requeter la base : <br>SQL : $query <br>".mysql_errno($commande->link)." - ".mysql_error());
			
		$row = mysql_fetch_array($resul);
		$status = $row[0];		
		//resultat
		return $status;
	 }

	
	/*
	Redefinition de la methode (constructeur) Cnx de la classe Cnx
	*/


	/* 
		getCnxFunction: contenu de la nouvelle fonction Cnx 
	*/
	function getCode_Cnx_CnxFunction(){
		$code ='
			$this->link = MysqlStaticConnection::getHandle();
		';
		return $code;
	}


	/*
		methode  redefine_Cnx_function : inclure le code PHP de redfinition des fichiers de classe modifis
	*/

	function redefine_Cnx_function() {
		/*
		appel de la fonction : bool runkit_method_redefine  ( string $classname  , string $methodname  , string $args  , string $code  [, int $flags = RUNKIT_ACC_PUBLIC  ] )
		*/
		$boolResult = runkit_method_redefine(
			'Cnx',
			'Cnx',
			'',
			$this->getCode_Cnx_CnxFunction(),
			RUNKIT_ACC_PUBLIC
		);
		
		/* ajouter une constante indicateur pour savoir si la redefinition est ok */
		if($boolResult) 
			define  ( "CONST_ZFOPTIMISATION_MOTEUR_CNX", "optimized" );
		 
	} //end function


	/*
	getClasstoArray : debug d'une classe
	*/
	function getClasstoArray($data) {
	    if (is_object($data)) $data = get_object_vars($data);
	    return is_array($data) ? array_map(__FUNCTION__, $data) : $data;
	}


	
	/*
	redefinition de getVars de la classe BaseObj.class.php
	*/
	public static $result_cache = array();
        
        function getCode_BaseObj_getVarsFunction(){
			$code ='
						$query = func_get_arg(0);
				
						global $objZFoptimisationcache;
						$arr_result_cache = array();
						if(!isset($objZFoptimisationcache)) {
							$objZFoptimisationcache = new Zfquerycache();
							$filename = realpath(dirname(__FILE__)) . "/classes/zfquery.log";
							$content=date("d/m/Y H:i:s").";getCode_BaseObj_getVarsFunction: creation objet objZFoptimisationcache";
							$objZFoptimisationcache->LogFile($filename, $content);
						}
						
		            		$arr_result_cache = $objZFoptimisationcache->getCache();
				        	$hash = hash("md5", $query);
						
			            if (array_key_exists($hash, $arr_result_cache) && $arr_result_cache[$hash]!="" ){
			                	$row = $arr_result_cache[$hash];
			            }else{
						   $filename = realpath(dirname(__FILE__)) . "/classes/zfquery.log";
						   $content=date("d/m/Y H:i:s").";getCode_BaseObj_getVarsFunction: requete : ".$query;
						   $objZFoptimisationcache->LogFile($filename, $content);

			                if(! $resul = mysql_query($query, $this->link)) return 0;
			                 $row = mysql_fetch_object($resul);
			                 $arr_result_cache[$hash]=$row;
			                 $objZFoptimisationcache ->doCache($arr_result_cache);
						   $filename = realpath(dirname(__FILE__)) . "/classes/zfquery.log";
						   $content=date("d/m/Y H:i:s").";getCode_BaseObj_getVarsFunction: stockage du cache : hash = ".$hash;
						   $objZFoptimisationcache->LogFile($filename, $content);
			            }
			            
			            if($row)  {
				                foreach($this->bddvars as $var){
				                    $this->$var = $row->$var;
				                }
				                return 1;    
			            }else {
				                return 0;
			            }
			                
			            return mysql_num_rows($resul);
		            
		            '; 
		            
		            return $code;
            
        } //end function 

	
	/*
		methode  redefine_Cnx_function : inclure le code PHP de redfinition des fichiers de classe modifis
	*/

	function redefine_BaseObj_getVars_function() {
		/*
		appel de la fonction : bool runkit_method_redefine  ( string $classname  , string $methodname  , string $args  , string $code  [, int $flags = RUNKIT_ACC_PUBLIC  ] )
		*/
		$classname = "BaseObj";
		$methodname = "getVars";
		
		$boolResult = runkit_method_redefine(
			$classname,
			$methodname,
			'',
			$this->getCode_BaseObj_getVarsFunction(),
			RUNKIT_ACC_PUBLIC
		);
		
		/* ajouter une constante indicateur pour savoir si la redefinition est ok */
		if($boolResult) 
			define( "CONST_ZFOPTIMISATION_MOTEUR_BASEOBJ_GETVARS", "optimized" );
		 
	}



	function get_memory_usage() {
        $mem_usage = memory_get_usage(true);
       
        if ($mem_usage < 1024)
            return $mem_usage." octects";
        elseif ($mem_usage < 1048576)
            return round($mem_usage/1024,2)." Ko";
        else
            return round($mem_usage/1048576,2)." Mo";
    } 

} //end class

?>