<?php
/*************************************************************************************/
/*                                                                                   */
/*      Thelia	                                                            		 */
/*                                                                                   */
/*      Copyright (c) Octolys Development		                                     */
/*		email : thelia@octolys.fr		        	                             	 */
/*      web : http://www.octolys.fr						   							 */
/*************************************************************************************/
/*      Module Optimisation de Thelia  									*/
/*      Script : Zfoptimisationmoteur.class.php                                               */
/*      Copyright (c) ZEOS-FRANCE                                                    */
/*      email : contact@zeos-france.fr                                               */
/*		plugin ralis  partir des informations d'optimisation fournies par :
		- roadster31 : optimisations moteur
		- pierrezf		: creation des index non uniques sur les colonnes de certaines tables			*/
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/

/*
Obligatoire : pre-chargement des fichiers de classe sur lesquels le plugin intervient 
*/

include_once(realpath(dirname(__FILE__)) . "/../../../classes/Cnx.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Baseobj.class.php");

require_once realpath(dirname(__FILE__))."/classes/Zfquerycache.class.php";
require_once realpath(dirname(__FILE__))."/Zfoptimisationmoteur.class.php";

$obj_optimisation = new Zfoptimisationmoteur();
if($obj_optimisation->checkIsEnabled()){
	//si plugin actif alors appliquer les optimisations
	
	/* optimisation de la connexion MySQL */
	$obj_optimisation->redefine_Cnx_function();
	
	/* Cache des requtes */
	$obj_optimisation->redefine_BaseObj_getVars_function();
	
}

/*
instance d'objet cache 
*/
global $objZFoptimisationcache;
$objZFoptimisationcache = $obj_optimisation->objZFoptimisationcache;
$filename = realpath(dirname(__FILE__)) . "/classes/zfquery.log";
$content=date("d/m/Y H:i:s").";getCode_BaseObj_getVarsFunction: creation objet objZFoptimisationcache";
$objZFoptimisationcache->LogFile($filename, $content);

?>