<?php
/*************************************************************************************/
/*                                                                                   */
/*      Thelia	                                                            		 */
/*                                                                                   */
/*      Copyright (c) Octolys Development		                                     */
/*		email : thelia@octolys.fr		        	                             	 */
/*      web : http://www.octolys.fr						   							 */
/*************************************************************************************/
/*      Module Optimisation de Thelia                                    */
/*      Script : Zfoptimisationmoteur.class.php                                               */
/*      Copyright (c) ZEOS-FRANCE                                                    */
/*      email : contact@zeos-france.fr                                               */
/*		plugin ralis  partir des informations d'optimisation fournies par :
		- roadster31 : optimisations moteur
		- pierrezf		: creation des index non uniques sur les colonnes de certaines tables			*/
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/

include_once(realpath(dirname(__FILE__)) . "/../../../fonctions/authplugins.php");
autorisation("zfoptimisationmoteur");

require_once(realpath(dirname(__FILE__)) . "/Zfoptimisationmoteur.class.php");

 
 /*
 test pour verifier si le plugin tourne effectivement
  */
 
 $html_cnx = "<br>Optimisation de la classe de connexion MySQL - Cnx->Cnx() :";
 if(CONST_ZFOPTIMISATION_MOTEUR_CNX=="optimized") {
 	$html_cnx .= "<font color=\"green\"><b>Ok</b></font>";
 }else{
 		$html_cnx .="<font color=\"red\"><b>Inactif</b></font>";
 }


$html_baseobj_getvars = "<br>Activation du cache des requetes SQL (par page)  - BaseObj->getVars : ";
 if(CONST_ZFOPTIMISATION_MOTEUR_BASEOBJ_GETVARS=="optimized") {
 	$html_baseobj_getvars.= "<font color=\"green\"><b>ok</b></font>";
 }else{
 		$html_baseobj_getvars .= "<font color=\"red\"><b>Inactif</b></font>";
 }
 
 
 $memory_usage= $obj_optimisation->get_memory_usage();
 $html_memory_usage = "<br>Memoire utilis&eacute;e par PHP : ".$memory_usage;
// print_r($_SESSION);
 //global $GLOBAL_ZF_QUERY_CACHE;
 ?>
 <div id="contenu_int">
	 <div>
	 	<b>Statut de l'optimisation de Zfoptimisationmoteur :</b>
		<?=$html_cnx?> 
		<?=$html_baseobj_getvars?> 
		<?=$html_memory_usage?>
		<br><br><b>Liste des fichiers inclus :</b>
		<?php
		$included_files = get_included_files();
		foreach ($included_files as $filename) {
		    echo "<br>$filename";
		}
		?>
	</div>
</div>